<template>
	<!-- 营销-积分商品 -->
	<div>
		<Card :bordered="false" dis-hover class="ivu-mt" :padding="0">
			<div class="new_card_pd">
				<!-- 查询条件 -->
				<Form ref="tableFrom" inline :model="tableFrom" :label-width="labelWidth"
					:label-position="labelPosition" @submit.native.prevent>
					<!-- <FormItem label="创建时间：" label-for="user_time">
            <DatePicker
                :editable="false"
                @on-change="onchangeTime"
                :value="timeVal"
                format="yyyy/MM/dd"
                type="datetimerange"
                placement="bottom-start"
                placeholder="自定义时间"
                class="mr20 input-add"
                :options="options"
            ></DatePicker>
          </FormItem> -->
					<!-- <FormItem label="上架状态：">
            <Select
                placeholder="请选择"
                clearable
                class="input-add"
                v-model="tableFrom.is_show"
            >
              <Option value="1">上架</Option>
              <Option value="0">下架</Option>
            </Select>
          </FormItem> -->
					<FormItem label="仓库：" prop="pid" label-for="pid">
						<Select v-model="tableFrom.wid" @on-change="userSearchs" clearable class="input-add">
							<Option v-for="item in data1" :value="item.id" :key="item.id">
								{{ item.title }}
							</Option>
						</Select>
					</FormItem>
					<FormItem label="门店：">
						<Select v-model="tableFrom.store_id" clearable filterable @on-change="userSearchs"
							class="input-add">
							<Option v-for="item in staffData" :value="item.id" :key="item.id">{{ item.name }}
							</Option>
						</Select>
					</FormItem>
					<FormItem label="创建人：">
						<Select v-model="tableFrom.create_uid" clearable filterable @on-change="userSearchs"
							class="input-add">
							<Option v-for="item in authList" :value="item.id" :key="item.id">{{ item.staff_name }}
							</Option>
						</Select>
					</FormItem>
					<!-- <FormItem label="用户搜索：" label-for="store_name">
						<Input class="input-add mr14" placeholder="请输入用户昵称/手机号" v-model="tableFrom.key" />
						<Button type="primary" @click="tableSearchs()">查询</Button>
					</FormItem> -->
					<!-- <Button
            v-auth="['marketing-store_seckill-create']"
            type="primary"
            icon="md-add"
            @click="addMore"
            class="mr10"
            >批量添加积分商品</Button
          > -->
					<!--<Button v-auth="['export-storeSeckill']" class="export" icon="ios-share-outline" @click="exports">导出</Button>-->
				</Form>
			</div>
		</Card>
		<Card :bordered="false" dis-hover class="ivu-mt">
			<!-- 操作 -->
			<Button v-auth="['marketing-store_seckill-create']" type="primary" @click="add" class="mr10">添加要货</Button>
			<!-- 积分商品-表格 -->
			<Table :columns="columns1" :data="tableList" :loading="loading" highlight-row no-userFrom-text="暂无数据"
				no-filtered-userFrom-text="暂无筛选结果" class="ivu-mt">
				<template slot-scope="{ row, index }" slot="image">
					<viewer>
						<div class="tabBox_img">
							<img v-lazy="row.avatar" />
						</div>
					</viewer>
				</template>
				<template slot-scope="{ row, index }" slot="create_time">
					<span> {{ row.create_time | formatDate }}</span>
				</template>
				<template slot-scope="{ row, index }" slot="auth_time">
					<span v-if="row.auth_time"> {{ row.auth_time | formatDate }}</span>
				</template>
				<template slot-scope="{ row, index }" slot="pm">
					<div>{{row.pm == 1?'入':'出'}}库</div>
				</template>
				<template slot-scope="{ row, index }" slot="auser">
					<div>名称：{{row.auser.staff_name}}</div>
					<div>管理员ID：{{row.auser.admin_id}}</div>
					<div>ID:{{row.auser.id}}</div>
					<div>手机：{{row.auser.phone}}</div>
				</template>
				<template slot-scope="{ row, index }" slot="cuser">
					<div>名称：{{row.cuser.staff_name}}</div>
					<div>管理员ID：{{row.cuser.admin_id}}</div>
					<div>ID:{{row.cuser.id}}</div>
					<div>手机：{{row.cuser.phone}}</div>
				</template>
				<template slot-scope="{ row, index }" slot="ware">
					<div>名称：{{row.ware.title}}</div>
					<div>ID:{{row.ware.id}}</div>
					<div>手机：{{row.ware.phone}}</div>
					<div>地址：{{row.ware.detailed_address}}</div>
				</template>
				<template slot-scope="{ row, index }" slot="info">
					<!-- {{row.info}} -->
					<div v-for="item in row.info" class="info">
						<div>
							商品名称：{{item.product_name}}
						</div>
						<div>
							商品ID：{{item.product_id}}
						</div>
						<div v-if="item.is_weigh == 1">
							净重：{{item.net_weight}}
						</div>
						<div v-if="item.is_weigh == 1">
							皮重：{{item.tare_weight}}
						</div>
					</div>
				</template>
				<template slot-scope="{ row, index }" slot="store">
					<viewer style="display: flex;">
						<div class="tabBox_img">
							<img v-lazy="row.store.image" />
						</div>
						<div>门店：{{row.store.name}}<br>ID：{{row.store.id}}</div>
					</viewer>

				</template>
				<template slot-scope="{ row, index }" slot="is_system">
					<span> {{ row.is_system ? '是': '否'}}</span>
				</template>
				<template slot-scope="{ row, index }" slot="is_show">
					<i-switch v-model="row.is_show" :value="row.is_show" :true-value="1" :false-value="0"
						@on-change="onchangeIsShow(row)" size="large">
						<span slot="open">上架</span>
						<span slot="close">下架</span>
					</i-switch>
				</template>
				<template slot-scope="{ row, index }" slot="status">
					<Tag color="default" v-if="row.status == 0">待审核</Tag>
					<Tag color="primary" v-if="row.status == 1">已审核</Tag>
					<Tag color="success" v-if="row.status == 2">完成</Tag>
				</template>
				<template slot-scope="{ row, index }" slot="action">
					<a @click="look(row)">详情</a>
					<template v-if="row.to_store_id && row.status == 0">
						<Divider type="vertical" />
						<a @click="pass(row)">审核</a>
					</template>
					<!-- <Divider type="vertical" />
					<a @click="del(row, '删除积分商品', index)">删除</a> -->
				</template>
			</Table>
			<div class="acea-row row-right page">
				<Page :total="total" :current="tableFrom.page" show-elevator show-total @on-change="pageChange"
					:page-size="tableFrom.limit" />
			</div>
		</Card>
		<Modal v-model="modalpass" scrollable title="审核" class="order_box" :closable="false" :mask-closable="false">
			<Form ref="remarks" :model="remarks" :label-width="80" @submit.native.prevent>
				<FormItem label="审核人：">
					<Select v-model="remarks.auth_uid" clearable filterable @on-change="userSearchse" class="input-add">
						<Option v-for="item in authLists" :value="item.id" :key="item.id">{{ item.staff_name }}
						</Option>
					</Select>
				</FormItem>
				<FormItem label="状态：">
					<Select v-model="remarks.status" clearable filterable class="input-add">
						<Option :value="1">通过</Option>
						<Option :value="-1">拒绝</Option>
						<!-- <Option :value="2" >部分完成</Option>
				<Option :value="3" >完成</Option>
				<Option :value="-2" >无效</Option> -->
					</Select>
				</FormItem>
			</Form>
			<div slot="footer">
				<Button type="primary" @click="putRemark()">提交</Button>
				<Button @click="cancel()">取消</Button>
			</div>
		</Modal>
		<receiveDetail ref="receiveDetail"></receiveDetail>
	</div>
</template>

<script>
	import receiveDetail from './receiveDetail.vue'
	import {
		mapState
	} from "vuex";
	import {
		integralProductListApi,
		integralIsShowApi,
		storeSeckillApi,
	} from "@/api/marketing";
	import {
		getWantList,
		getUserInfo,
		getGodownList,
		getUserList,
		getReceiveList,
		storeAuth
	} from "@/api/erp";
	import {
		staffListInfo
	} from "@/api/store";
	import {
		formatDate
	} from "@/utils/validate";
	import timeOptions from "@/utils/timeOptions";
	import Setting from "@/setting";
	export default {
		name: "receiveIndex",
		components: {
			receiveDetail
		},
		filters: {
			formatDate(time) {
				if (time !== 0) {
					let date = new Date(time * 1000);
					return formatDate(date, "yyyy-MM-dd hh:mm:ss");
				}
			},
		},
		data() {
			return {
				authLists: [],
				remarks: {
					id: 0,
					status: '',
					auth_uid: "",
					auth_admin_id: "",
				},
				modalpass: false,
				roterPre: Setting.roterPre,
				loading: false,
				options: timeOptions,
				columns1: [{
						title: "ID",
						key: "id",
						width: 80,
					},
					// {
					// 	title: "订单编号",
					// 	key: "order_id",
					// 	minWidth: 150,
					// },

					{
						title: "出库单号",
						key: "out_order_id",
						minWidth: 150,
					},
					{
						title: "出入库",
						slot: "pm",
						minWidth: 150,
					},
					{
						title: '商品信息',
						slot: 'info',
						minWidth: 300,
					},
					// {
					// 	title: "门店信息",
					// 	slot: "store",
					// 	minWidth: 200,
					// },
					{
						title: "创建人",
						slot: "cuser",
						minWidth: 200,
					},
					{
						title: "总数量",
						key: "total_num",
						minWidth: 90,
					},
					{
						title: "运费",
						key: "freight",
						minWidth: 90,
					},
					{
						title: "总价格",
						key: "total_price",
						minWidth: 90,
					},
					// {
					// 	title: "仓库信息",
					// 	slot: "ware",
					// 	minWidth: 200,
					// },
					{
						title: "审核人",
						slot: "auser",
						minWidth: 200,
					},
					{
						title: '审核时间',
						slot: 'auth_time',
						minWidth: 80,
					},
					{
						title: "状态",
						slot: "status",
						minWidth: 100,
					},
					{
						title: "创建时间",
						slot: "create_time",
						minWidth: 90,
					},
					{
						title: "操作",
						slot: "action",
						fixed: "right",
						width: 200,
					},
				],
				tableList: [],
				timeVal: [],
				grid: {
					xl: 7,
					lg: 10,
					md: 12,
					sm: 24,
					xs: 24,
				},
				tableFrom: {
					// integral_time: "",
					// is_show: "",
					// store_name: "",
					// key: '',
					create_uid: "",
					store_id: "",
					wid: "",
					page: 1,
					limit: 15,
					type: -1,
					status: -3,
					// store_id: 3
				},
				total: 0,
				staffData: [],
				data1: [],
				authList: []
			};
		},
		computed: {
			...mapState("admin/layout", ["isMobile"]),
			labelWidth() {
				return this.isMobile ? undefined : 96;
			},
			labelPosition() {
				return this.isMobile ? "top" : "right";
			},
		},
		created() {
			this.getList();
		},
		mounted() {
			this.getGodownList()
			this.staffList()
			this.getUserList()
		},
		methods: {
			look(row) {
				this.$refs.receiveDetail.storeInfo(row.id);
			},
			userSearchse(e) {
				let auth = this.authLists.find(item => item.id == e)
				this.remarks.auth_admin_id = auth.admin_id
			},
			pass(row) {
				let qdata = {}
				if (row.to_wid) {
					qdata.wid = row.to_wid
				} else {
					qdata.store_id = row.to_store_id
				}
				this.authLists = []
				this.remarks.id = row.id
				getUserList(qdata).then(res => {
					this.authLists = res.data.data
					this.modalpass = true;
				})
			},
			putRemark() {
				storeAuth(this.remarks).then(res => {
					this.cancel()
					this.getList();
				})
			},
			cancel() {
				this.remarks = {
					id: 0,
					status: '',
					auth_uid: "",
					auth_admin_id: "",
				}
				this.modalpass = false
			},
			getUserList() {
				getUserList().then(res => {
					// console.log(res);
					this.authList = res.data.data
				})
			},
			userSearchs(e) {
				this.tableFrom.page = 1;
				this.getList();
			},
			getGodownList() {
				getGodownList().then(res => {
					console.log(res);
					this.data1 = res.data.data
				})
			},
			staffList() {
				staffListInfo()
					.then((res) => {
						this.staffData = res.data;
					})
					.catch((err) => {
						this.$Message.error(err.msg);
					});
			},
			// 添加
			add() {
				this.$router.push({
					path: this.roterPre + "/marketing/store_integral/create"
				});
			},
			addMore() {
				this.$router.push({
					path: this.roterPre + "/marketing/store_integral/add_store_integral",
				});
			},
			orderList(row) {
				this.$router.push({
					path: this.roterPre + "/marketing/store_integral/order_list",
					query: {
						product_id: row.id,
					},
				});
			},
			// 导出
			exports() {
				let formValidate = this.tableFrom;
				let data = {
					start_status: formValidate.start_status,
					status: formValidate.status,
					store_name: formValidate.store_name,
				};
				storeSeckillApi(data)
					.then((res) => {
						location.href = res.data[0];
					})
					.catch((res) => {
						this.$Message.error(res.msg);
					});
			},
			// 编辑
			edit(row) {
				try {
					getUserInfo(row.id).then(res => {
						console.log(res)
					})
				} catch (e) {
					//TODO handle the exception
					console.log('zhje', e);
				}

				// this.$router.push({
				// 	path: this.roterPre + "/marketing/store_integral/create/" + row.id + "/0",
				// });
			},
			// 一键复制
			copy(row) {
				this.$router.push({
					path: this.roterPre + "/marketing/store_integral/create/" + row.id + "/1",
				});
			},
			// 删除
			del(row, tit, num) {
				let delfromData = {
					title: tit,
					num: num,
					url: `marketing/integral/${row.id}`,
					method: "DELETE",
					ids: "",
				};
				this.$modalSure(delfromData)
					.then((res) => {
						this.$Message.success(res.msg);
						this.tableList.splice(num, 1);
						if (!this.tableList.length) {
							this.tableFrom.page =
								this.tableFrom.page == 1 ? 1 : this.tableFrom.page - 1;
						}
						this.getList();
					})
					.catch((res) => {
						this.$Message.error(res.msg);
					});
			},
			// 列表
			getList() {
				this.loading = true;
				this.tableList = []
				// this.tableFrom.start_status = this.tableFrom.start_status || "";
				// this.tableFrom.is_show = this.tableFrom.is_show || "";
				getReceiveList(this.tableFrom)
					.then(async (res) => {
						let data = res.data;
						this.tableList = data.data;
						this.total = data.count;
						this.loading = false;
					})
					.catch((res) => {
						this.loading = false;
						this.$Message.error(res.msg);
					});
			},
			pageChange(index) {
				this.tableFrom.page = index;
				this.getList();
			},
			// 表格搜索
			tableSearchs() {
				this.tableFrom.page = 1;
				this.getList();
			},
			// 具体日期
			onchangeTime(e) {
				this.timeVal = e;
				this.tableFrom.integral_time = this.timeVal[0] ? this.timeVal.join("-") : "";
			},
			// 修改是否显示
			onchangeIsShow(row) {
				let data = {
					id: row.id,
					is_show: row.is_show,
				};
				integralIsShowApi(data)
					.then(async (res) => {
						this.$Message.success(res.msg);
					})
					.catch((res) => {
						this.$Message.error(res.msg);
					});
			},
		},
	};
</script>

<style scoped lang="stylus">
	.tabBox_img {
		width: 36px;
		height: 36px;
		border-radius: 4px;
		cursor: pointer;

		img {
			width: 100%;
			height: 100%;
		}
	}

	.info {
		padding-top: 10px;
		border-bottom: 1px dashed #515a6e;

		&:last-of-type {
			border: none;
		}
	}
</style>